require 'yaml'
module Hermes
  class RexClient::Configuration

    attr_accessor :auth_url
    attr_accessor :base_url
    attr_accessor :ed_entity
    attr_accessor :ed_lessor
    attr_accessor :client_id
    attr_accessor :client_secret
    attr_accessor :username
    attr_accessor :password
    attr_accessor :logger

    def logger=(value)
      @logger=case value
                when String
                  case value.downcase
                    when 'stdout'
                      Logger.new(STDOUT)
                    when 'stderr'
                      Logger.new(STDERR)
                    else
                      nil
                  end
                else
                  value
              end
    end

    def proxy
      RestClient.proxy
    end

    def proxy=(value)
      RestClient.proxy=value
    end

    def initialize(attrs={})
      self.auth_url                 = attrs.fetch(:auth_url, "https://rec.client.almerys.com/auth/realms/ALS/protocol/openid-connect/token")
      self.base_url                 = attrs.fetch(:base_url, "https://idrex-int.be-idys.com/id-rex-front-ws/context/55497564-c203-4047-b1ee-477550161834")
      self.ed_entity                = attrs.fetch(:ed_entity, "21191a5e-594f-4a2b-b6d0-884b9c6ca11e")
      self.ed_lessor                = attrs.fetch(:ed_lessor, "44e8e76d-e22f-405e-9072-4fab40b737eb")
      self.client_id                = attrs.fetch(:client_id, "id-rex_back")
      self.client_secret            = attrs.fetch(:client_secret, "6f593606-2306-4617-82b4-d0061a0f2d04")
      self.username                 = attrs.fetch(:username, "idrex_test_user_user_rw")
      self.password                 = attrs.fetch(:password, "Almerys*2000")
      self.proxy                    = attrs.fetch(:proxy, nil)
      self.logger                   = attrs.fetch(:logger, nil)

    end

    def self.from_yaml(path, env=nil)
      attrs = YAML.load_file(path)
      attrs = attrs[env] if env
      sym_attrs=attrs.each_with_object({}) {|(k, v), memo| memo[k.to_sym] = v}
      self.new(sym_attrs)
    end

  end
end